*基准回归
use 基准数据.dta,clear
xtset id year
reghdfe CRED DID , absorb(id year) vce(cl id)
 outreg2 using regression_results.doc, word replace ctitle(1) bdec(3) dec(2) rdec(3)
 reghdfe CRED DID  GOV  , absorb(id year) vce(cl id)
  outreg2 using regression_results.doc, append word ctitle(2) bdec(3) dec(2) rdec(3)
 reghdfe CRED DID   GOV  SCL  , absorb(id year) vce(cl id)
 outreg2 using regression_results.doc, append word ctitle(3) bdec(3) dec(2) rdec(3)
 reghdfe CRED DID  GOV  SCL TAX, absorb(id year) vce(cl id)
  outreg2 using regression_results.doc, append word ctitle(4) bdec(3) dec(2) rdec(3)
 reghdfe CRED DID  GOV  SCL TAX  OPEN, absorb(id year) vce(cl id)
  outreg2 using regression_results.doc, append word ctitle(5) bdec(3) dec(2) rdec(3)
  reghdfe CRED DID  GOV  SCL TAX  OPEN TRS  , absorb(id year) vce(cl id)
   outreg2 using regression_results.doc, append word ctitle(6) bdec(3) dec(2) rdec(3)
 reghdfe CRED DID  GOV  SCL TAX  OPEN TRS  IND  , absorb(id year) vce(cl id)
  outreg2 using regression_results.doc, append word ctitle(7) bdec(3) dec(2) rdec(3)
  reghdfe CRED DID  GOV  SCL TAX  OPEN TRS  IND  ARI, absorb(id year) vce(cl id)
   outreg2 using regression_results.doc, append word ctitle(8) bdec(3) dec(2) rdec(3)
***平行趋势检验检验
* 1. 生成政策年份差变量, 创建pre, current, post的虚拟变量
**pre_6 表示干预前第6期的数据、pre_5 表示干预前第5期的数据、las_1 表示干预后的第1期数据（以此类推）、curren表示干预发生的"当期"。
reghdfe CRED pre_6  pre_5 pre_4 pre_3 pre_2   current las_1 las_2 las_3 las_4 las_5 las_6 las_7 las_8 las_9 las_10 las_11 las_12 TRS  GOV IND   SCL TAX  OPEN  ARI ,absorb(id year) vce(cl id)
cap matrix drop B1
global list1 "current las_1 las_2 las_3 las_4 las_5 las_6 las_7 las_8 las_9 las_10 las_11 las_12" 
foreach wid1 in $list1 {
  qui esttab, se
  matrix tmp=r(coefs)
  matrix tmp=tmp["`wid1'".."`wid1'",.]

  matrix B1=(nullmat(B1)\tmp)
}
cap matrix drop B2
global list2 "pre_6  pre_5 pre_4 pre_3 pre_2  "
foreach wid2 in $list2 {
  qui esttab, se
  matrix tmp=r(coefs)
  matrix tmp=tmp["`wid2'".."`wid2'",.]
  matrix B2=(nullmat(B2)\tmp)
}

svmat B1, names(reg_D1k6)
svmat B2, names(reg_Dm1k6)
save "DID_CMJJ_0620.dta",replace
use "DID_CMJJ_0620.dta",clear
keep reg_D1k61-reg_D1k62
rename _all (b se_b)
keep in 1/13
gen T=_n
gen z=T-1
save "DID_CMJJ_0621.dta",replace
use "DID_CMJJ_0620.dta",clear
keep reg_Dm1k61-reg_Dm1k62
rename _all (b se_b)
keep in 1/6
gen T=_n
gen z=T-7
save "DID_CMJJ_0622.dta",replace
use "DID_CMJJ_0621.dta",clear
append using "DID_CMJJ_0622.dta"
save "DID_CMJJ_0622.dta",replace
use "DID_CMJJ_0622.dta",clear
replace b=0 if z==-1
gen UB=b+1.645*se_b
gen LB=b-1.645*se_b
sort z
replace LB=0 if z==-1
replace UB=0 if z==-1
graph set window fontface "Times New Roman"
twoway (connect b z if z>=-6.2 & z<=-1, sort lcolor(gs1) lpattern(dash) mcolor(gs1) msymbol(circle_hollow) cmissing(n)) (connect b z if z>=-1 & z<=12.2, sort lcolor(gs1) lpattern(dash) mcolor(gs1) msymbol(circle_hollow) cmissing(n)) (line LB z if z>=-6.2 & z<=12.2, lcolor(gs10) lwidth(thin) lpattern(dash) msize(medium)) (line UB z if z>=-6.2 & z<=12.2, lcolor(gs10) lwidth(thin) lpattern(dash) msize(medium)), ytitle("β") ytitle(,size(medium) height(2)) yline(0, lwidth(vthin) lpattern(dash) lcolor(red)) ylabel(, labsize(small) angle(horizontal) nogrid) xtitle("Year") xtitle(, size(medium)) xline(-1, lwidth(vthin) lpattern(dash) lcolor(red)) xlabel(-6(1)12,labsize(small)) ylabel(-3(0.5)1, labsize(small)) legend(off) graphregion(fcolor(white) lcolor(white) ifcolor(white) ilcolor(white)) 

**稳健性检验
use 基准数据.dta,clear
xtset id year
 reghdfe TI DID  GOV  SCL TAX  OPEN TRS  IND   ARI  , absorb(id year) vce(cl id)
 reghdfe G  DID  GOV  SCL TAX  OPEN TRS  IND   ARI  , absorb(id year) vce(cl id)
  reghdfe CRED Strong_DID  GOV  SCL TAX  OPEN TRS  IND   ARI  ,  absorb(id year) vce(cluster id )  
 reghdfe CRED DID DID_1  GOV  SCL TAX  OPEN TRS  IND   ARI  ,  absorb(id year) vce(cluster id ) 
 drop if province == "西藏" | province == "内蒙古" | province == "浙江" | province == "山东"
 reghdfe CRED DID   GOV  SCL TAX  OPEN TRS  IND   ARI ,  absorb(id year) vce(cluster id )
 *bacondecomp
 use 基准数据.dta,clear
 bacondecomp CRED post treatment    GOV  SCL TAX  OPEN TRS  IND   ARI    ,ddetail cluster(id)
 
 
 ***安慰剂检验
 use 基准数据.dta,clear
xtset id year
capture erase "simulations0.dta"
program define placebo_500, rclass
    reghdfe CRED  DID   GOV  SCL TAX  OPEN TRS  IND   ARI ,  absorb(id year) vce(cluster id )
    return scalar beta = _b[DID]
    return scalar se = _se[DID]
    return scalar df = e(df_r)
end
permute DID beta=r(beta) se=r(se) df=r(df), reps(500) seed(777) saving("simulations0.dta"): placebo_500
use "simulations0.dta", clear
gen t_value = beta / se
gen p_value = 2 * ttail(df, abs(t_value))
graph set window fontface "Times New Roman"  
graph set window fontfacesans "宋体" 
twoway (scatter p_value beta, msymbol(smcircle_hollow) mcolor(blue))(kdensity beta,yaxis(2)), yline(0.1,lp(shortdash)) xlabel(-1(0.2)1) xline(-0.516,lp(shortdash))

*内生性检验
*省内其他城市到省会城市的平均距离作为工具变量
 use 基准数据.dta,clear
ivreg2 CRED ( DID = new_IV )   GOV  SCL TAX  OPEN TRS  IND  ARI  i.year i.id, robust first

***异质性检验
*城市数量
reghdfe CRED DID  GOV  SCL TAX  OPEN TRS  IND ARI  if city_count_group ==1, absorb(id year) vce(cl id)
reghdfe CRED DID  GOV  SCL TAX  OPEN TRS  IND ARI  if city_count_group ==0, absorb(id year) vce(cl id)
*距离
reghdfe CRED DID  GOV  SCL TAX  OPEN TRS  IND ARI  if city_dis_group_dis==1, absorb(id year) vce(cl id)
reghdfe CRED DID  GOV  SCL TAX  OPEN TRS  IND ARI  if city_dis_group_dis ==0, absorb(id year) vce(cl id)
**费舍尔
bdiff, group( city_count_group ) model( reghdfe CRED DID   GOV  SCL TAX  OPEN TRS IND ARI,absorb( id year) vce(cl id)) bs reps(2000) detail seed(213)
bdiff, group( city_dis_group_dis ) model( reghdfe CRED DID   GOV  SCL TAX  OPEN TRS IND ARI,absorb( id year) vce(cl id)) bs reps(2000) detail seed(312)
**三重差分
reghdfe CRED DID_city_count_group  GOV  SCL TAX  OPEN TRS  IND   ARI , absorb(id year) vce(cl id)
reghdfe CRED DID_city_dis_group_dis  GOV  SCL TAX  OPEN TRS  IND   ARI , absorb(id year) vce(cl id)

**传导机制分析
use 机制数据.dta,clear
xtset city_id year
reghdfe HHI_jiuye did gov scl tax open tras ind ari ,absorb( city_id year) vce(cl city_id)
reghdfe total_yiersan did gov scl tax open tras ind  ari,absorb( city_id year) vce(cl city_id)
reghdfe pgdp_growth_rate did gov scl tax open tras ind ari ,absorb( city_id year) vce(cl city_id)
**删除省会城市
drop if capital_city_flag==1 
reghdfe pgdp_growth_rate did gov scl tax open tras ind ari ,absorb( city_id year) vce(cl city_id)
**在删除省会城市的基础上，删除副中心城市
drop if new_treatment ==1
reghdfe pgdp_growth_rate did gov scl tax open tras ind  ari,absorb( city_id year) vce(cl city_id)
**进一步分析
use 机制数据.dta,clear
*省会、副中心城市与中小城市对比
reghdfe pgdp_growth_rate did gov scl tax open tras ind  ari if candsub ==0,absorb( city_id year) vce(cl city_id)
reghdfe pgdp_growth_rate did gov scl tax open tras ind  ari if candsub ==1,absorb( city_id year) vce(cl city_id)
*费舍尔
bdiff, group( candsub ) model( reghdfe pgdp_growth_rate did gov scl tax open tras ind  ari,absorb( city_id year) vce(cl city_id)) bs reps(2000) detail seed(456)
*相对速度
reghdfe Relative_Growth_nc did gov scl tax open tras ind ari ,absorb( city_id year) vce(cl city_id)
